clear all; close all;
%
T=1024*4; K=200; N=1000;
% noises
KrOut=0.5; KrIn=0.5
;
% regularization constants
lamb1=1.5;  % DC
lamb2=1000;   % norm
%--------
u0=randn(T,1);
%------------------------
[bcoeff,acoeff]=butter(1,0.01); 
y0=10*filter(bcoeff,acoeff,u0); 
figure(1), subplot(211), plot(u0(1:N)); grid;  title('Input');
subplot(212), plot(y0(1:N)); grid; title('Output');
%-noisy input measurement ------------
um=u0+KrIn*randn(size(u0));
%- measurement matrix ----------
%u=um(1+K:N+K); ur=um(1+K:-1:1); 
u=um(1:N); ur=[um(1) zeros(1,K)]; 
H=toeplitz(u,ur);   

%- matrices for regularization -------------
YY=zeros(1+K,1+K);
for i=1:1+K, for j=1:1+K, YY(i,j)=(.9^abs(i-j))*exp(-.02*(i+j)); end; end;
EE1=lamb1*inv(YY);   % DC
EE2=lamb2*eye(1+K);  % norm

%-- noisy output measurement -------------
ym=y0+KrOut*randn(size(y0));
%y=y0(1+K:N+K); ym=y1(1+K:N+K);
y1=y0(1:N); y2=ym(1:N);               %y2=sign(y2);
%-- estimates --------------------
gpls=inv(H'*H)*H'*y1; 
gnls=inv(H'*H)*H'*y2; 
gnlsr1=inv(H'*H+EE1)*H'*y2;
gnlsr2=inv(H'*H+EE2)*H'*y2;
%-------------------------------
figure(3), stem(gpls,'k'); grid; hold on;  
stem(gnls,'r'); 
hold off; title('k - LS, r - noisy LS'); 
%pause;
%----------------
figure(5), stem(gpls,'k'); grid; hold on; 
stem(gnls,'r'); stem(gnlsr2,'g'); hold off;
title('k - LS, r - noisy LS, g - regularized(norm)'); 
%pause;
%--------------------------
figure(4), stem(gpls,'k'); grid; hold on;  
stem(gnls,'r'); stem(gnlsr1,'b'); hold off;
title('k - LS, r - noisy LS, b - regularized(DC)'); 





